/**
 * @file errnums.h
 * @brief This file stores definitions of errors definitions used in project
 * 
 */
 
#ifndef ERRNUMS_H_
#define ERRNUMS_H_

/** Seed for error is defined to prevent collision with pre made files definitions if any */
#define ERR_SEED -10
/** Pseudo error number, indicate succes */
#define EOK 0
/** No memory available error */ 
#define ENOMEM -1 + ERR_SEED
/** Invalid argument error */
#define EINVAL -2 + ERR_SEED
/** Waiting thread canceled error */
#define EKILLED -3 + ERR_SEED
/** Timeout exceedde error */     
#define ETIMEDOUT -4 + ERR_SEED
/** Operation would block another thread error */    
#define EWOULDBLOCK -5 + ERR_SEED
/** Queue, list or another structure is empty */
#define EEMPTY -6 + ERR_SEED
/** Queue, list or another strucuture don't contain desired item */
#define ENOTEXISTS -7 + ERR_SEED
/** Thread queue structure isn't empty */
#define ENOTEMPTY -8 + ERR_SEED

/** Definition of TRUE */
#define TRUE 1
/** Definition of FALSE */
#define FALSE 0

#endif /*ERRNUMS_H_*/
